package music;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import art.Artist;

/**
 * Write a description of class Performer here.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class Performer extends Musician implements Artist, Serializable {
    
    private String name;
    private String origin;
    private int age;
    
    private static final long serialVersionUID = 567975L;
    
    public Performer(String name, String origin, int age) {
        this.name = name;
        this.origin = origin;
        this.age = age;
    }
    
    public Performer(String name, String origin) {
        this.name = name;
        this.origin = origin;
    }
    
    public Performer() {
    }
    
    public void serialize(String filename) {
    	
    	File f = new File(filename);
    	
    	try {
			ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(f));
			out.writeObject(this);
			out.flush();
			out.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    }
    
    public static Performer deserialize(String filename) {
    	
    	Performer p = null;
    	File f = new File(filename);
    	
    	try {
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
			p = (Performer) in.readObject();
			in.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	return p;
    	
    }
    
    @Override
    public String toString() {
    	return this.name + ", " + this.origin + "; " + this.age;
    }
    
	@Override
	public void create() {
		System.out.println("I am playing...");
	}

	@Override
	public void showArtType() {
		System.out.println("Music");
	}

	@Override
	public void describe() {
		System.out.println("Performer");
	}
    
    @Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + age;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result + ((origin == null) ? 0 : origin.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Performer other = (Performer) obj;
		if (age != other.age)
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (origin == null) {
			if (other.origin != null)
				return false;
		} else if (!origin.equals(other.origin))
			return false;
		return true;
	}

	public void setName(String name) {
        this.name = name;
    }
    
    public String getName() {
        return this.name;
    }
    
    public void setOrigin(String origin) {
        this.origin = origin;
    }
    
    public String getOrigin() {
        return this.origin;
    }
    
    public void setAge(int age) {
        this.age = age;
    }
    
    public int getAge() {
        return this.age;
    }

}
